Subject: Re: [RFC net-next 00/15] devlink: code split and structured instance walk

From: Jacob Keller <[email-masked]>
Date: Thu, 15 Dec 2022 11:39:11 -0800

On 12/14/2022 6:01 PM, Jakub Kicinski wrote:
> Hi!
> 
> I started working on the refcounting / registration changes
> and (as is usual in our profession) I quickly veered off into
> refactoring / paying technical debt. I hope this is not too
> controversial.
> 
> ===
> 
> Split devlink.c into a handful of files, trying to keep the "core"
> code away from all the command-specific implementations.
> The core code has been quite scattered before. Going forward we can
> consider using a source file per-subobject, I think that it's quite
> beneficial to newcomers (based on relative ease with which folks
> contribute to ethtool vs devlink). But this series doesn't split
> everything out, yet - partially due to backporting concerns,
> but mostly due to lack of time. 
> 
> Introduce a context structure for dumps, and use it to store
> the devlink instance ID of the last dumped devlink instance.
> This means we don't have to restart the walk from 0 each time.
> 
> Finally - introduce a "structured walk". A centralized dump handler
> in devlink/netlink.c which walks the devlink instances, deals with
> refcounting/locking, simplifying the per-object implementations quite
> a bit.
> 

I'm fine with the series as-is.

Reviewed-by: Jacob Keller <[email-masked]>

Moving the dumpit_one thing into generic netlink files seems ok, but I
trust you may have already thought about and decided it was too devlink
specific.

Thanks,
Jake